# Poco

# class UUIDGenerator

Library: Foundation
Package: UUID
Header: Poco/UUIDGenerator.h

## Description

This class implements a generator for Universal Unique Identifiers, as specified in Appendix A of the DCE 1.1 Remote Procedure Call Specification (http://www.opengroup.org/onlinepubs/9629399/), RFC 2518 (WebDAV), section 6.4.1 and the UUIDs and GUIDs internet draft by Leach/Salz from February, 1998 (http://ftp.ics.uci.edu/pub/ietf/webdav/uuid-guid/draft-leach-uuids-guids-01.txt)

## Member Summary

Member Functions: create, createFromName, createOne, createRandom, defaultGenerator, getNode, timeStamp

## Constructors

### UUIDGenerator

UUIDGenerator();

Creates the UUIDGenerator.

## Destructor

### ~UUIDGenerator

~UUIDGenerator();

Destroys the UUIDGenerator.

## Member Functions

### create

UUID create();

Creates a new time-based UUID, using the MAC address of one of the system's ethernet adapters.

Throws a SystemException if no MAC address can be obtained.

### createFromName

UUID createFromName(
const UUID & nsid,
const std::string & name
);

Creates a name-based UUID.

### createFromName

UUID createFromName(
const UUID & nsid,
const std::string & name,
DigestEngine & de
);

Creates a name-based UUID, using the given digest engine.

### createOne

UUID createOne();

Tries to create and return a time-based UUID (see create()), and, if that does not work due to the unavailability of a MAC address, creates and returns a random UUID (see createRandom()).

The UUID::version() method can be used to determine the actual kind of the UUID generated.

### createRandom

UUID createRandom();

Creates a random UUID.

### defaultGenerator

static UUIDGenerator & defaultGenerator();

Returns a reference to the default UUIDGenerator.

### getNode

void getNode();

### timeStamp

Timestamp::UtcTimeVal timeStamp();